//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  Green
#property indicator_color2  Maroon
#property indicator_color3  LimeGreen
#property indicator_color4  PaleVioletRed
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

#import "wininet.dll"
      int  DeleteUrlCacheEntry(string fileName);
#import "urlmon.dll"
      int  URLDownloadToFileA(int caller, string url, string fileMame, int reserved, int CallBackStatus);
#import "kernel32.dll"
      int  GetTimeZoneInformation(int& tzinfo[]);
#import

//
//
//
//
//

extern string _                         = "General display";
extern bool  DisplayNews                = true;
extern bool  DisplayDailyData           = false;
extern bool  DisplayMarkers             = true;
extern bool  DisplayOnlyCurrentSymbol   = false;
extern color HighImpactColor            = Red;
extern color MediumImpactColor          = Orange;
extern color LowImpactColor             = DarkGray;
extern string __.                       = "";
extern string __                        = "News settings";
extern bool  DisplayDescription         = false;
extern bool  DisplayDate                = false;
extern bool  DisplayWholeWeek           = false;
extern bool  AdjustTimeAutomatically    = true;
extern int   AdjustTimeZoneGMT          = 0;
extern int   DisplayCorner              = 3;
extern int   YDisplacement              = 10;
extern int   XDisplacement              = 10;
extern color BetterColor                = Green;
extern color WorseColor                 = Red;
extern color TextColor                  = DarkGray;
extern string ___.                      = "";
extern string ___                       = "News markers settings";
extern bool  DisplayPastMarkers         = true;
extern bool  DisplayFutureMarkers       = true;
extern bool  DisplayMarkersForWholeWeek = false;
extern int   AdjustBrokerGMT            = 0;
extern int   MarkerWidth                = 2;
extern bool  MarkerAsBackgroud          = false;
extern string ____.                     = "";
extern string ____                      = "Daily display settings";
extern color DailyZoneColor             = C'255,238,210';
extern int   DailyCandleShift           = 8;
extern int   DailyVerticalShift         = 15;
extern bool  DailyShowInfo              = True;
extern bool  DailyShowSwap              = True;
extern bool  DailyShowBackground        = True;
extern bool  DailyShowBar               = True;
extern string _____                     = "alerts settings";
extern bool   alertsOn                  = false;
extern bool   alertsMessage             = true;
extern bool   alertsBefore              = true;
extern int    alertsBeforeMinutes       = 10;
extern bool   alertsAfter               = true;
extern int    alertsAfterMinutes        = 10;
extern bool   alertsSound               = false;
extern bool   alertsEmail               = false;
extern bool   alertsOnlyCurrentSymbol   = false;
extern bool   alertsOnLowImpact         = true;
extern bool   alertsOnMediumImpact      = true;
extern bool   alertsOnHighImpact        = true;
bool DisplayActual = false;

//
//
//
//
//

#define uniqueID   "TSDNewsRead:"
#define globalName "TSDNewsUpdate"
#define Timer 60
#define CalendarID 4

int    timeZoneInfo[43];
int    timeZoneAdjust;
double DayHigh[];
double DayLow[];
double DayOpen[];
double DayClose[];
int    DataPeriod;


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init() 
{
   GlobalVariableSet(globalName,0);
   SetIndexBuffer(0, DayHigh);
   SetIndexBuffer(1, DayLow);
   SetIndexBuffer(2, DayClose);
   SetIndexBuffer(3, DayOpen);
      if (DailyShowBar)
         for (int i=0;i<4;i++)
            {
               SetIndexStyle(i,DRAW_HISTOGRAM);
               SetIndexShift(i,DailyCandleShift);
               SetIndexLabel(i,"Daily data");
            }            
      else  for (i=0;i<4;i++) SetIndexStyle(i,DRAW_NONE);

      //
      //
      //
      //
      //
            
      switch(Period())
      {
         case PERIOD_MN1:
         case PERIOD_W1:  DataPeriod = PERIOD_MN1; break;
         case PERIOD_D1:  DataPeriod = PERIOD_W1;  break;
         default:         DataPeriod = PERIOD_D1;
      }
   
      //
      //
      //
      //
      //
   
      if (AdjustTimeAutomatically)
      {
         int tzType = GetTimeZoneInformation(timeZoneInfo);
         if (tzType == 2)
               timeZoneAdjust = 60*(timeZoneInfo[0]+timeZoneInfo[42]);
         else  timeZoneAdjust = 60*(timeZoneInfo[0]);
      }         
      else timeZoneAdjust = -AdjustTimeZoneGMT*3600;
      if (DisplayWholeWeek) DisplayDate = true; start();
   return(0);
}

//
//
//
//

int deinit()
{
   switch(UninitializeReason())
   {
      case REASON_CHARTCHANGE: break;
      case REASON_PARAMETERS: 
      case REASON_RECOMPILE:
      case REASON_CHARTCLOSE:
      case REASON_REMOVE:
      case REASON_ACCOUNT:    deleteObjects();
   }
   return(0);
}

//
//
//
//
//

void deleteObjects(string add="")
{
   string lookFor       = uniqueID+add;
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string name = ObjectName(i);
      if (StringSubstr(name,0,lookForLength)==lookFor) ObjectDelete(name);
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   if (!IsDllsAllowed()) doAlert(" DLL import should be allowed for news reader");
   if (DisplayDailyData) showDailyData();
   if (DisplayNews)      showNews();
   if (DisplayMarkers)   showMarkers();
   if (alertsOn)         manageAlerts();
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string news[][10];
#define _date        0
#define _time        1
#define _currency    2
#define _description 3
#define _rating      4
#define _actual      5
#define _forecast    6
#define _previous    7
#define _rdate       8
#define _rtime       9


//
//
//
//
//

void showMarkers()
{
   deleteObjects("marker");
      if (Period()>PERIOD_H4)                           return;
      if (!DisplayPastMarkers && !DisplayFutureMarkers) return;
         datetime lastChecked = updateArray();
         if (lastChecked==0) return;
   
         //
         //
         //
         //
         //

         double dummy = iMA(NULL,PERIOD_H1,1,0,0,0,0);
         int    day   = TimeDay(iTime(NULL,PERIOD_H1,0));
         int    size  = ArrayRange(news,0),i,k;

         for (i=0,k=0; i<size; i++)
         {
            int dayItem = TimeDay(StrToTime(news[i][_rdate]));
            if ((DisplayMarkersForWholeWeek || day==dayItem) && checkSymbol(news,i,DisplayOnlyCurrentSymbol))
            {
               datetime time = StrToTime(news[i][_rdate]+" "+news[i][_rtime]);
                     if (DisplayPastMarkers   && time<=Time[0]) displayMarker(time,i,false);
                     if (DisplayFutureMarkers && time> Time[0]) displayMarker(time,i,true);
            }
         }
}

//
//
//
//
//

void displayMarker(datetime time, int i, bool future)
{
   if (!future)
   {
      int forBar = iBarShift(NULL,0,time); time = Time[forBar];
         double priceUp = High[forBar];
         double priceDn = Low[forBar];
   }
   else 
   {
      int timeDiff  = (time-Time[0])/60;
      int timeShift = NormalizeDouble(timeDiff/Period(),0);
         time    = Time[0]+timeShift*Period()*60;
         priceUp = High[0];
         priceDn = Low[0];
   }
   
   //
   //
   //
   //
   //
   
      string name = uniqueID+"marker:"+time;
      color  col  = impactColor(news,i);
      
      if (ObjectFind(name)==-1)
            ObjectCreate(name,OBJ_TREND,0,0,0);
      else  
         {
            color tmpCol = ObjectGet(name,OBJPROP_COLOR);
            while(true)
            {
                if (tmpCol == HighImpactColor)                             { col = HighImpactColor;   break; }
                if (tmpCol == MediumImpactColor && col != HighImpactColor) { col = MediumImpactColor; break; }
                                                                                                      break;
            }                
         }
            ObjectSet(name,OBJPROP_PRICE1,priceUp);
            ObjectSet(name,OBJPROP_PRICE2,priceDn);
            ObjectSet(name,OBJPROP_TIME1,time);
            ObjectSet(name,OBJPROP_TIME2,time);
            ObjectSet(name,OBJPROP_COLOR,col);
            ObjectSet(name,OBJPROP_WIDTH,MarkerWidth);
            ObjectSet(name,OBJPROP_BACK,MarkerAsBackgroud);
            ObjectSet(name,OBJPROP_RAY,false);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void showNews()
{
   datetime lastChecked = updateArray();
      if (lastChecked==0) return;
      
      //
      //
      //
      //
      //
      
      double dummy = iMA(NULL,PERIOD_H1,1,0,0,0,0);
      bool   left  = (DisplayCorner == 0 || DisplayCorner == 2);
      int    day   = TimeDay(iTime(NULL,PERIOD_H1,0));
      int    size  = ArrayRange(news,0),i,k;

            for (i=0,k=0; i<size; i++)
            {
               int dayItem = TimeDay(StrToTime(news[i][_date]));
               if ((DisplayWholeWeek || day==dayItem) && checkSymbol(news,i,DisplayOnlyCurrentSymbol)) { displayItem(i,k+1,left); k++; }
            }
            if (DisplayCorner == 0 || DisplayCorner == 1)
                  int ypos = YDisplacement+(k+1)*11+3;
            else      ypos = YDisplacement-3;
            
            //
            //
            //
            //
            //
            
         objectCreate("news9:"+0,XDisplacement,ypos,"last downladed at "+TimeToStr(lastChecked,TIME_SECONDS)+" local time",9,"Arial",TextColor,DisplayCorner);
   return;
}

//
//
//
//
//

void displayItem(int i,int k, bool left)
{
   int xpos = XDisplacement;
   if (left)
   {
      if (DisplayDate) 
      {
         objectCreate("news1:"+k,xpos,YDisplacement+k*11,StringSubstr(news[i][_date],5,5),10,"Courier new",TextColor,DisplayCorner ); xpos += 45;
      }         
      objectCreate("news2:"+k,xpos,YDisplacement+k*11,news[i][_time]    ,10,"Courier new",TextColor          ,DisplayCorner); xpos += 45;
      objectCreate("news3:"+k,xpos,YDisplacement+k*11,news[i][_currency],10,fontName(i)  ,impactColor(news,i),DisplayCorner); xpos += 30;  
      if (DisplayDescription)
      {
         objectCreate("news4:"+k,xpos,YDisplacement+k*11,pad(news[i][_description],30,false),10,fontName(i),impactColor(news,i),DisplayCorner); xpos += 200;
      }            
      if (DisplayActual) 
      {
         objectCreate("news5:"+k,xpos,YDisplacement+k*11,pad(news[i][_actual]  ,10,true),10,fontName(i),TextColor,DisplayCorner); xpos += 55;
      }         
      objectCreate("news6:"+k,xpos,YDisplacement+k*11,pad(news[i][_forecast],10,true),10,fontName(i),TextColor,DisplayCorner); xpos += 55;
      objectCreate("news7:"+k,xpos,YDisplacement+k*11,pad(news[i][_previous],10,true),10,fontName(i),TextColor,DisplayCorner);
   }
   else
   {
      objectCreate("news7:"+k,xpos,YDisplacement+k*11,pad(news[i][_previous],10,true),10,fontName(i),TextColor,DisplayCorner); xpos += 55;  
      objectCreate("news6:"+k,xpos,YDisplacement+k*11,pad(news[i][_forecast],10,true),10,fontName(i),TextColor,DisplayCorner); xpos += 55;  
      if (DisplayActual) 
      {
         objectCreate("news5:"+k,xpos,YDisplacement+k*11,pad(news[i][_actual]  ,10,true),10,fontName(i),TextColor,DisplayCorner); xpos += 55;  
      }         
      if (DisplayDescription)
      {
         objectCreate("news4:"+k,xpos,YDisplacement+k*11,pad(news[i][_description],30,false),10,fontName(i),impactColor(news,i),DisplayCorner); xpos += 245;
      }         
      objectCreate("news3:"+k,xpos,YDisplacement+k*11,news[i][_currency],10,fontName(i)  ,impactColor(news,i),DisplayCorner); xpos += 30;  
      objectCreate("news2:"+k,xpos,YDisplacement+k*11,news[i][_time]    ,10,"Courier new",TextColor     ,DisplayCorner); xpos += 45;
      if (DisplayDate) 
      {
         objectCreate("news1:"+k,xpos,YDisplacement+k*11,StringSubstr(news[i][_date],5,5),10,"Courier new",TextColor,DisplayCorner);
      }         
   }      
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------  
//
//
//
//
//

datetime updateArray()
{
   static datetime lastChecked    = 0;
   static datetime lastDayChecked = 0;
   static string   fileName       = "";
   bool            readFile       = false;
      
      if ((lastChecked+Timer)<TimeLocal() || lastDayChecked!=TimeDay(iTime(NULL,PERIOD_H1,0)))
      { 
         fileName = getNewsFile(); 
         if (fileName != "")
         {
            lastChecked    = TimeLocal(); 
            lastDayChecked = TimeDay(iTime(NULL,PERIOD_H1,0));
            readFile       = true; 
         }
      }
      if (fileName == "") return(0);
         
      //
      //
      //
      //
      //
      
      int size = 0;
      if (readFile)
      {
         int handle = FileOpen(fileName,FILE_CSV|FILE_READ,';'),i=0;
         if (handle < 0) return;
            
            //
            //
            //
            //
            //
            
            for(i=0;!FileIsEnding(handle);i++)
            {
               ArrayResize(news,i+1);
                  string date = FileReadString(handle); string rdate = date;
                  string time = FileReadString(handle); string rtime = time;
                     adjustDateTime(rdate,rtime,true);
                        news[i][_rdate]       = rdate;
                        news[i][_rtime]       = rtime;
                     adjustDateTime(date,time,false);
                        news[i][_date]        = date;
                        news[i][_time]        = time;
                        news[i][_currency]    = StringTrimLeft(StringTrimRight(FileReadString(handle)));
                        news[i][_description] = StringTrimLeft(StringTrimRight(FileReadString(handle)));
                        news[i][_rating]      = StringTrimLeft(StringTrimRight(FileReadString(handle)));
                        news[i][_actual]      = StringTrimLeft(StringTrimRight(FileReadString(handle)));
                        news[i][_forecast]    = StringTrimLeft(StringTrimRight(FileReadString(handle)));
                        news[i][_previous]    = StringTrimLeft(StringTrimRight(FileReadString(handle)));
            }
            FileClose(handle); size = ArrayRange(news,0); 
            if (DisplayCorner == 2 || DisplayCorner == 3)
            {
               string tempNews[][10];
                  ArrayResize(tempNews,size);
                  for (int k=0; k<size; k++)
                  for (int j=0; j<10;   j++)
                     tempNews[size-k-1][j] = news[k][j];
                  for (k=0; k<size; k++)
                  for (j=0; j<10;   j++)
                     news[k][j] = tempNews[k][j];
            }
            deleteObjects("news");
      }            
      return(lastChecked);
}

//
//
//
//
//

string getNewsFile()
{
   if (GlobalVariableGet(globalName)!= 0) return("");
       GlobalVariableSet(globalName,1);

   //
   //
   //
   //
   //

      double dummy   = iMA(NULL,PERIOD_W1,1,0,0,0,0);
      string tmpTime = TimeToStr(iTime(NULL,PERIOD_W1,0),TIME_DATE);
      string strTime = StringSubstr(tmpTime,0,4)+StringSubstr(tmpTime,5,2)+StringSubstr(tmpTime,8,2);
      string dnlFile = TerminalPath()+"\\experts\\files\\ForexTSD"+strTime+".csv";
      string dnlLink = "http://calendar.forex-tsd.com/calendar.php?csv=1&date="+strTime+"&calendar[]="+CalendarID;

         int delResult = DeleteUrlCacheEntry(dnlFile);
         int dowResult = URLDownloadToFileA(0,dnlLink,dnlFile,0,0);

   //
   //
   //
   //
   //
   
   GlobalVariableSet(globalName,0);
   if (dowResult==0)
         return("ForexTSD"+strTime+".csv");   
   else  return("");
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------  
//
//
//
//
//

void showDailyData()
{
   string symbol   = Symbol(); if (StringSubstr(symbol,0,2)=="_t") symbol = StringSubstr(symbol,2);
   int    digits   = MarketInfo(symbol,MODE_DIGITS);
   double modifier = 1;
   
   if (digits==3 || digits==5) modifier = 10.0;
   else 
         if (ObjectFind(uniqueID+"16") != -1) ObjectDelete(uniqueID+"16");
      
   //
   //
   //
   //
   //
           
   int dataBar = iBarShift(symbol,DataPeriod,Time[0]);
      double HiDAILY  = iHigh (symbol,DataPeriod,dataBar);
      double LoDAILY  = iLow  (symbol,DataPeriod,dataBar); 
      double current  = iClose(symbol,DataPeriod,dataBar);
      double range    = getRange(DataPeriod,symbol,dataBar)/modifier;
      double change   = (current-iOpen(symbol,DataPeriod,dataBar))/(MarketInfo(symbol,MODE_POINT)*modifier);
      
   //
   //
   //
   //
   //

   if (DailyShowInfo)
   {
      if (ObjectFind(uniqueID+"1") ==-1) 
      {
         objectCreate("1",10,DailyVerticalShift+10,"-------------------------------------------",10,NULL);  
         objectCreate("3",60,DailyVerticalShift+32,"distance from high : ");
         objectCreate("4",60,DailyVerticalShift+44,"distance from low : " );
         objectCreate("5",60,DailyVerticalShift+56,"spread : " );
         objectCreate("6",10,DailyVerticalShift+68,"-------------------------------------------",10,NULL);
         if (DailyShowSwap)
         {
            objectCreate("2",60,DailyVerticalShift+20,"change/range : ");
            objectCreate("7",60,DailyVerticalShift+76,"swap long : "         );
            objectCreate("8",60,DailyVerticalShift+88,"swap short : "        );
            objectCreate("9",10,DailyVerticalShift+96,"-------------------------------------------",10,NULL);  
         }
         else
         {
            objectCreate("2",60,DailyVerticalShift+20,"range : "       );
            objectCreate("7",60,DailyVerticalShift+76,"distance from open : ");
            objectCreate("9",10,DailyVerticalShift+88,"-------------------------------------------",10,NULL);  
         }                     
      }

      //
      //
      //
      //
      //

      static double prevCurr = -1;
      if (prevCurr != current)
      {
         prevCurr = current;
            double currFromHi = (HiDAILY-current)/(MarketInfo(symbol,MODE_POINT)*modifier);
            double currFromLo = (current-LoDAILY)/(MarketInfo(symbol,MODE_POINT)*modifier);

            //
            //
            //
            //
            //
                  
            objectCreate("0",128,DailyVerticalShift+0,symbol,10,"Arial bold",YellowGreen);  
 
               if (DailyShowSwap)
                     objectCreate("11",10,DailyVerticalShift+20,DoubleToStr(change,0)+"/"+DoubleToStr(range,0)  ,10,"Arial bold",PaleVioletRed);
               else  objectCreate("11",10,DailyVerticalShift+20,                          DoubleToStr(range,0)  ,10,"Arial bold",PaleVioletRed);
 
            objectCreate("12",10,DailyVerticalShift+32,DoubleToStr(currFromHi,0)                             ,10,"Arial bold",YellowGreen);
            objectCreate("13",10,DailyVerticalShift+44,DoubleToStr(currFromLo,0)                             ,10,"Arial bold",YellowGreen);
            objectCreate("14",10,DailyVerticalShift+56,DoubleToStr(MarketInfo(symbol,MODE_SPREAD)/modifier,2),10,"Arial bold",YellowGreen);
   
               if (DailyShowSwap)
                  {
                     objectCreate("15",10,DailyVerticalShift+76,DoubleToStr(MarketInfo(symbol,MODE_SWAPLONG),2) ,10,"Arial bold",YellowGreen);
                     objectCreate("16",10,DailyVerticalShift+88,DoubleToStr(MarketInfo(symbol,MODE_SWAPSHORT),2),10,"Arial bold",YellowGreen);
                  }
               else
                  {
                     if (change<0)
                           objectCreate("15",10,DailyVerticalShift+76,DoubleToStr(change,0) ,10,"Arial bold",Red);
                     else  objectCreate("15",10,DailyVerticalShift+76,DoubleToStr(change,0) ,10,"Arial bold",Gold);
                  }
            
            //
            //
            //
            //
            //
            
            string currentValue = DoubleToStr(current,digits);                  
            objectCreate("17",10, DailyVerticalShift+0,currentValue,12,"Arial bold",YellowGreen);  
            if (modifier !=1)
               objectCreate("18",10,DailyVerticalShift+0,StringSubstr(currentValue,StringLen(currentValue)-1),12,"Arial bold",Gray);  
         }   
   }           
   setBarIndicator(change,HiDAILY,LoDAILY,iOpen(symbol,DataPeriod,dataBar),current,dataBar);
   
   //
   //
   //
   //
   //
   
   for(int i=0;i<4;i++) SetIndexDrawBegin(i,Bars-1); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------  
//
//
//
//
//

void setBarIndicator(double change, double hi,double low, double open, double close,int DataBar)
{
   string name  = uniqueID+"-1";
   int    shift = 0;
   
   if (change>0) { DayHigh[shift]  = hi;  DayLow[shift] = low; }            
   else          { DayHigh[shift]  = low; DayLow[shift] = hi;  }            
                   DayOpen[shift]  = open;
                   DayClose[shift] = close;

   if (DailyShowBackground)
      {                         
         if (ObjectFind(name) == -1)
             ObjectCreate(name,OBJ_RECTANGLE,0,0,0);
             ObjectSet(name,OBJPROP_TIME1,iTime(NULL,DataPeriod,DataBar));
             ObjectSet(name,OBJPROP_TIME2,iTime(NULL,         0,0));
             ObjectSet(name,OBJPROP_PRICE1,hi);
             ObjectSet(name,OBJPROP_PRICE2,low);
             ObjectSet(name,OBJPROP_COLOR,DailyZoneColor);
      }
}

//
//
//
//
//

double getRange(int period, string symbol, int DataBar)
{
      double range = iHigh(symbol, period, DataBar) - iLow(symbol, period, DataBar);
      return (NormalizeDouble(range/MarketInfo(symbol,MODE_POINT),0));
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------  
//
//
//
//
//
   
void objectCreate(string sname,int x,int y,string text="-",int size=10,
                  string font="Arial",color colour=DimGray,int corner=1, int window = 0)
{
   string name = uniqueID+sname;
   if (ObjectFind(name)==-1)
       ObjectCreate(name,OBJ_LABEL,window,0,0);
          ObjectSet(name,OBJPROP_CORNER,corner);
          ObjectSet(name,OBJPROP_XDISTANCE,x);
          ObjectSet(name,OBJPROP_YDISTANCE,y);
          ObjectSetText(name,text,size,font,colour);
}

//
//
//
//
//
   
string fontName(int i)
{
   if (news[i][_rating]=="3")
         return("Courier new bold");
   else  return("Courier new");
}

color impactColor(string& news[][10],int i)
{
   if (news[i][_rating]=="3") return(HighImpactColor);
   if (news[i][_rating]=="2") return(MediumImpactColor);
   else                       return(LowImpactColor);
}

string pad(string what,int size, bool left, string padChar=" ")
{
   int sizes = StringLen(what);
   string pre="",pos=padChar;
      if (left) { pre=padChar; pos=""; }
      for (int k=size-sizes; k>0; k--) what = pre+what+pos;
                   return(StringSubstr(what,0,size));
}

//
//
//
//
//

bool checkSymbol(string& news[][10], int i, bool displayOnlyCurrentSymbol)
{
   string first  = StringSubstr(Symbol(),0,3);
   string second = StringSubstr(Symbol(),3,3);
   if (displayOnlyCurrentSymbol)
         return(first==news[i][_currency] || second==news[i][_currency]);
   else  return(news[i][_currency]!="");
}

//
//
//
//
//

void adjustDateTime(string& date, string& time, bool isBroker)
{
   string tTime = date+" "+time;
      if (isBroker)
            datetime dTime = StrToTime(tTime)+AdjustBrokerGMT*3600;
      else           dTime = StrToTime(tTime)-timeZoneAdjust;
      tTime = TimeToStr(dTime,TIME_DATE|TIME_MINUTES);
      date  = StringSubstr(tTime,0,10);
      time  = StringSubstr(tTime,11,0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------  
//
//
//
//
//

void manageAlerts()
{
   int size = ArrayRange(news,0);
   int day  = TimeDay(TimeCurrent());
   for (int i=0; i<size; i++)
   {
      bool eventCanBeAlerted = false;
      if (alertsOnLowImpact    && news[i][_rating]=="1") eventCanBeAlerted = true;
      if (alertsOnMediumImpact && news[i][_rating]=="2") eventCanBeAlerted = true;
      if (alertsOnHighImpact   && news[i][_rating]=="3") eventCanBeAlerted = true;
      if (eventCanBeAlerted && checkSymbol(news,i,alertsOnlyCurrentSymbol))
      {
         datetime time = StrToTime(news[i][_date]+" "+news[i][_time]);
            if (alertsBefore && (time-TimeLocal())>=0 && (time-TimeLocal())<=alertsBeforeMinutes*60)                                                  doAlert(" news comming in less than"+alertsBeforeMinutes+" minutes");
            if (alertsAfter  && (TimeLocal()-time)>=0 && (TimeLocal()-time)>=alertsAfterMinutes *60 && (TimeLocal()-time)<=(alertsAfterMinutes+1)*60) doAlert(" news passed "+alertsAfterMinutes+" minutes ago");
      }            
   }
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static datetime previousTime =0;
   static string   previousAlert=""; 
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" news reader",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}